"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.flags = exports.positionals = exports.commandName = void 0;
var meow_1 = __importDefault(require("meow"));
var errors_1 = require("./errors");
var logUtils_1 = require("./logUtils");
function commandName() {
    if (cli.input[0] == undefined) {
        throw new errors_1.OrigeenError("You did not provide any command to execute.", [
            "Provide the command name as the first positional argument",
            "Type " + logUtils_1.bash("help") + " to see the generic help for Origeen"
        ]);
    }
    return cli.input[0];
}
exports.commandName = commandName;
function positionals() {
    return cli.input.slice(1);
}
exports.positionals = positionals;
function flags() {
    return cli.flags;
}
exports.flags = flags;
var cli = meow_1.default({
    autoHelp: false,
    autoVersion: true,
    flags: {
        debug: {
            type: "boolean",
            alias: "X",
            default: false,
        },
        warningOnly: {
            type: "boolean",
            alias: "W",
            default: false,
        },
        errorOnly: {
            type: "boolean",
            alias: "E",
            default: false,
        },
        help: {
            type: "boolean",
            alias: "h",
            default: false
        },
        force: {
            type: "boolean",
            default: false,
            required: false
        },
        template: {
            type: "string",
            alias: "t",
            default: "@empty",
            required: false
        },
        open: {
            type: "boolean",
            alias: "o",
            default: false,
            required: false
        },
        license: {
            type: "string",
            default: "ISC",
            required: false
        },
        noGit: {
            type: "boolean",
            default: false,
            required: false
        },
        set: {
            type: "string",
            alias: "s",
            required: false
        },
        local: {
            type: "string",
            alias: "l",
        },
        remote: {
            type: "string",
            alias: "r"
        }
    },
});
