export interface Command {
    name: string;
    description: string;
    alias: string[];
    positionals: Positional[];
    options: {
        [x: string]: Option;
    };
    run: () => Promise<void>;
}
export interface Positional {
    name: string;
    desc: string;
    required: boolean;
}
export interface Option {
    desc: string;
    alias?: string[];
    required: boolean | ((flags: {
        [x: string]: string | number | boolean;
    }) => boolean);
}
export declare const commands: Command[];
export declare function executeCommand(commandName: string): Promise<void>;
export declare function executeHelpCommand(commandName: string): void;
