"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.executeHelpCommand = exports.executeCommand = exports.commands = void 0;
var setup_1 = __importDefault(require("./commands/setup"));
var projects_1 = __importDefault(require("./commands/projects"));
var create_1 = __importDefault(require("./commands/create"));
var open_1 = __importDefault(require("./commands/open"));
var import_1 = __importDefault(require("./commands/import"));
var delete_1 = __importDefault(require("./commands/delete"));
var installTemplate_1 = __importDefault(require("./commands/installTemplate"));
var deleteTemplate_1 = __importDefault(require("./commands/deleteTemplate"));
var config_1 = __importDefault(require("./commands/config"));
var help_1 = __importDefault(require("./commands/help"));
var logUtils_1 = require("./logUtils");
var errors_1 = require("./errors");
exports.commands = [
    setup_1.default.descriptor,
    projects_1.default.descriptor,
    create_1.default.descriptor,
    open_1.default.descriptor,
    import_1.default.descriptor,
    delete_1.default.descriptor,
    installTemplate_1.default.descriptor,
    deleteTemplate_1.default.descriptor,
    config_1.default.descriptor,
    help_1.default.descriptor,
];
function executeCommand(commandName) {
    return __awaiter(this, void 0, void 0, function () {
        var debug, command;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    debug = console.debug;
                    command = findCommand(commandName);
                    debug("Executing command '" + commandName + "'");
                    return [4, command.run()];
                case 1:
                    _a.sent();
                    return [2];
            }
        });
    });
}
exports.executeCommand = executeCommand;
function executeHelpCommand(commandName) {
    var log = console.log, group = console.group, groupEnd = console.groupEnd;
    var command = findCommand(commandName);
    var positionals = command.positionals, options = command.options;
    var positionalsStr = positionals.reduce(function (previous, current) {
        return (previous +
            (current.required ? "<" + current.name + ">" : "[" + current.name + "]"));
    }, "");
    logUtils_1.h3("Usage");
    logUtils_1.bashBlock(commandName + " " + positionalsStr);
    logUtils_1.h3("Description:");
    log(command.description);
    logUtils_1.h3("Positionals");
    group();
    if (positionals.length === 0)
        console.log("No positionals");
    positionals.forEach(function (pos) {
        log("- " + pos.name + " : " + pos.desc);
    });
    groupEnd();
    logUtils_1.h3("Options");
    group();
    var optionsKeys = Object.keys(options);
    if (optionsKeys.length === 0)
        console.log("No options");
    optionsKeys.forEach(function (key) {
        var prefix = key.length === 1 ? "-" : "--";
        log("- '" + prefix + key + "' : " + options[key].desc);
    });
    groupEnd();
}
exports.executeHelpCommand = executeHelpCommand;
function findCommand(commandName) {
    var command = exports.commands.find(function (cmd) { return cmd.name === commandName || cmd.alias.includes(commandName); });
    if (command == undefined) {
        throw new errors_1.OrigeenError("Unknown command '" + commandName + "'", [
            "Check the spelling",
            "Show the help for Origeen with the '--help' flag",
        ]);
    }
    return command;
}
