"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var cli_1 = require("../cli");
var errors_1 = require("../errors");
var configUtils_1 = require("../configUtils");
var logUtils_1 = require("../logUtils");
var descriptor = {
    name: "config",
    description: "Get/Set values in the config file",
    run: function () { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
        return [2, execute()];
    }); }); },
    alias: [],
    positionals: [
        {
            name: "configName",
            desc: "The name of the config you want to get the value",
            required: false,
        },
    ],
    options: {
        set: {
            desc: "The new value for the property. Has an effect only if you provide a config name.",
            required: function (flags) {
                return flags.get == undefined;
            },
            alias: ["s"],
        },
    },
};
function execute() {
    var log = console.log, debug = console.debug;
    var config = configUtils_1.getConfig();
    var configName = cli_1.positionals()[0];
    var inputFlags = cli_1.flags();
    if (configName == undefined) {
        log(JSON.stringify(config, null, 4));
        return;
    }
    debug("Provided config name : '" + configName + "'");
    if (inputFlags.set == undefined) {
        debug("Reading config '" + configName + "'");
        if (config[configName] == undefined) {
            log("Config property '" + configName + "' is not defined yet");
            return;
        }
        debug("Property '" + configName + "' found");
        log("Value of '" + configName + "' is '" + config[configName.toString()] + "'");
        return;
    }
    logUtils_1.h1("Write mode");
    debug("Setting config " + configName);
    var newValue = inputFlags.set;
    if (typeof newValue !== "string") {
        throw new errors_1.OrigeenError("You put the '--set' flag, but did not give any value.", [
            "Insert a value after the '--set' flag",
            "Remove the '--set' flag",
            "Check that the given value is of type string.",
        ]);
    }
    configUtils_1.setProperty(configName, newValue);
    log("Set '" + configName + "' to '" + newValue + "'");
}
exports.default = { descriptor: descriptor };
