export interface Project {
    name: string;
    path: string;
    license?: string;
    createdAt?: number;
    importedAt?: number;
    lastOpenedAt: number;
    openings: number;
}
export declare function getProjects(): Project[];
export declare function projectExists(projectName: string): boolean;
export declare function isValidName(projectName: string): boolean;
export declare function getProject(projectName: string): Project;
export declare function getPathToProject(projectName: string): string;
export declare function createProject(projectName: string, templateName?: string, licenseName?: string, git?: boolean): void;
export declare function openProject(projectName: string): void;
export declare function importProject(pathToProject: string): void;
export declare function deleteProject(projectName: string): Promise<void>;
export declare function licenseProject(projectName: string, licenseName: string): void;
export declare function gitifyProject(projectName: string): void;
